{*********************************************************

 SlavaNap source code.

 Copyright 2001,2002 by CyberAlien@users.sourceforge.net
 Released under GNU General Public License

 Latest version is available at
 http://slavanap2.sourceforge.net

**********************************************************

 Unit: languages

 Form for selecting language

*********************************************************}
unit languages;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IniFiles, ComCtrls, ExtCtrls, StdCtrls;

type
  TSlavaNapLanguage = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    ksoOfficePanel1: TPanel;
    btn_ok: TButton;
    btn_cancel: TButton;
    list: TListView;
    procedure FormShow(Sender: TObject);
    procedure btn_cancelClick(Sender: TObject);
    procedure btn_okClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    modal: Boolean;
    procedure CreateParams(Var params: TCreateParams);override;
  end;

var
  SlavaNapLanguage: TSlavaNapLanguage;

implementation

uses mainform, vars, stypes, lang;

{$R *.DFM}

procedure TSlavaNapLanguage.CreateParams(Var params: TCreateParams);
begin
  inherited CreateParams( params );
   params.ExStyle := params.ExStyle and not WS_EX_TOOLWINDOW or WS_EX_APPWINDOW;
end;

procedure TSlavaNapLanguage.FormShow(Sender: TObject);
var
 i: Integer;
 item: TListItem;
 rec: TSearchRec;
 str, fname, lang, comments, ver: String;
 ini: TIniFile;
begin
 btn_cancel.Visible:=not modal;
 if language='' then language:='english';
 with list do
 begin
   Items.BeginUpdate;
   Items.Clear;
   i:=FindFirst(ApplicationDir+'*.lng',faAnyFile,rec);
   while i=0 do
   begin
     if (rec.attr and faDirectory)=0 then
      if rec.name<>'.' then
       if rec.name<>'..' then
       begin
         str:=AnsiLowerCase(ExtractFileName(rec.name));
         str:=Copy(str,1,Length(str)-4);
         fname:=str;
         lang:='';
         comments:='';
         ver:='';
         try
          ini:=TIniFile.Create(ApplicationDir+fname+'.lng');
          lang:=ini.ReadString('Version','Language','');
          comments:=ini.ReadString('Version','Comments','');
          ver:=ini.ReadString('Version','Version','');
          ini.Free;
          except
         end;
         if fname<>'' then
          if lang<>'' then
           if comments<>'' then
           begin
            item:=Items.Add;
            item.Caption:=lang;
            item.SubItems.Add(fname+'.lng');
            item.SubItems.Add(ver);
            item.SubItems.Add(comments);
            item.SubItems.Add(fname);
            if fname=language then
             item.Selected:=true;
           end;
       end;
     i:=FindNext(rec);
   end;
   FindClose(rec);
   Items.EndUpdate;
 end;
end;

procedure TSlavaNapLanguage.btn_cancelClick(Sender: TObject);
begin
 Close;
end;

procedure TSlavaNapLanguage.btn_okClick(Sender: TObject);
begin
 if list.Selected<>nil then
  language:=list.Selected.SubItems[3];
 Close;
 if btn_cancel.Visible and running then
 begin
  LoadLanguage(language);
  SlavaNapWindow.ChangeInterface;
 end;
end;

end.
  